const neode = require('../build')
    .fromEnv()



neode.cypher(`
    CALL db.schema.nodeTypeProperties()
    YIELD nodeType, nodeLabels, propertyName, propertyTypes, mandatory

    WITH nodeType, collect(nodeLabels) AS labels, collect({name: propertyName, types:propertyTypes, required: mandatory }) AS properties

    WITH collect({type: nodeType, labels: labels, properties: properties}) AS nodeProperties

    CALL db.schema.relTypeProperties()
    YIELD relType AS type, propertyName AS name, propertyTypes AS types, mandatory AS required
    WITH nodeProperties, type, collect({name: name, types: types, required: required}) AS properties
    WITH nodeProperties, collect({type: type, properties: properties}) AS relationshipProperties

    CALL db.schema.visualization()
    YIELD nodes, relationships

    RETURN *
`)
    .then(({ records }) => {
        const [ row ] = records;

        const output = row.get('nodeProperties').reduce((acc, node) => {
            const type = node.type.replace(/[^a-z0-9]+/ig, '')

            acc[ type ] = {
                labels: node.labels.reduce((acc, labels) => {
                    labels.forEach(label => {
                        if ( !acc.includes(label) ) acc.push(label)
                    });
                    
                    return acc;
                }, [])
            }


            node.properties.map(property => {
                acc[ type  ][ property.name ] = {
                    type: property.types[0].toLowerCase(),
                    required: property.required,
                }
                // console.log(property, property.types[0])
            })


            // if ( acc[type]._labels.length == 1 )  {
            //     delete acc[type]._labels
            // }



            // console.log(type, node)

            return acc;
        }, {})

        
        
        return output;
    })
    .then(res => console.log('\n\n', JSON.stringify(res, null, '    ')));


// console.log(neode)
